#ansible-playbook playbook-import-sfps-2-netbox.yml -e 'target=ios'

---

- name: Import SFPs from device in NetBox
  hosts: "{{ target }}"
  gather_facts: False
  any_errors_fatal: True
  
  tasks:

    - name: Install bottle python package on version 0.11
      ansible.builtin.pip:
        name: 
          - pynetbox==7.3.3

    - name: Capture raw command output
      ansible.netcommon.cli_command:
        command: show inventory
      register: raw_inventory_output

    - name: Extract and normalize interface details
      set_fact:
        sfps_sn: >-
          {%- set sfps = [] -%}
          {%- for line in raw_inventory_output.stdout | regex_findall('NAME:\\s+"([^"]+)",\\s+DESCR:\\s+"([^"]*SFP[^"]*)"\\n.*SN:\\s+(\\S+)') -%}
          {%-   set short_interface = line[0] -%}
          {%-   set sfp_type = line[1] -%}
          {%-   set serial_number = line[2] -%}
          {%-   set normalized_interface = short_interface
              | regex_replace('^Gi', 'GigabitEthernet')
              | regex_replace('^Te', 'TenGigabitEthernet')
              | regex_replace('^Twe', 'TwentyFiveGigE') -%}
          {%-   set first_digit = normalized_interface | regex_search('(\\d+)', '\\1') | first -%}
          {%-   set hostname_with_digit = (target ~ '-' ~ first_digit) if is_stack else target -%}
          {%-   set _ = sfps.append({'hostname': hostname_with_digit, 'interface': normalized_interface, 'sfp_type': sfp_type, 'serial_number': serial_number}) -%}
          {%- endfor -%}
          {{ sfps }}
      delegate_to: localhost
    
    - name: Create the netbox inventory role 
      ansible.builtin.include_role:
        name: netbox_inventory_item_role
        tasks_from: main.yml
      vars:
        item_role: "SFP"
    
    - name: Create the inventory item
      ansible.builtin.include_role:
        name: netbox_inventory_item
        tasks_from: main.yml
      vars:
        item_name: "{{ item['hostname'] ~ '_' ~ 'sfp' ~ '_' ~ item['interface'] }}"
        item_device: "{{ item['hostname'] }}"
        item_serial: "{{ item['serial_number'] }}"
        item_pardid: "{{ item['sfp_type'] }}"
        item_manufactur: "Cisco"
        item_inventory_role: "SFP"
        item_component_type: "dcim.interface"
        item_component_name: "{{ item['interface'] }}"
      loop: "{{ sfps_sn }}"
      loop_control:
        label: "Creating SFP {{ item['hostname'] ~ '_' ~ 'sfp' ~ '_' ~ item['interface'] }} for interface {{ item['interface'] }} with SN {{ item['serial_number'] }}"
